<?='<?xml version="1.0"?>'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
        <title>pOWL - Semantic Web Development Plattform</title>
	<link rel="stylesheet" type="text/css" href="style.css" />
</head>
<body>
<h1>Planned pOWL architecture</h1>
<h2>Frontend</h2>
<h3>Tab Modules</h3>
<p>Modules are independent PHP software packages, which access the pOWL
and other APIs (provided by the module itself, pOWL or 3rd parties).
Modules contain own user interfaces (e.g. in HTML / Javascript / CSS and PHP scripts).</p>
<p>By now implemented are:</p>
<ul>
	<li>Models</li>
	<li>RDF-Triples</li>
	<li>Classes</li>
	<li>Properties</li>
	<li>Instances</li>
</ul>
<p>Future releases may include e.g. consistancy checker / inference, export or visualisation modules.</p>
<p>Modules can be found in the <a href="powl/modules">"modules" subdirectory</a> of the pOWL distribution.</p>
<h3>Widgetplugins</h3>
<p>Widgetplugins for data editing. Widgets are special PHP-classes with methods for rendering the widget
and member variables defining required javascripts and CSS styles. Widgets don't implement complete user
interfaces as in contrast modules do.</p>
<p>By now implemented are:</p>
<ul>
	<li>Text</li>
	<li>Textarea</li>
	<li>Select</li>
	<li>Checkbox/Radio</li>
	<li>Date</li>
	<li>HTMLArea - WYSIWIG HTML editing</li>
	<li>Treeview - displaying of treestructures</li>
	<li>Tab - Tabs</li>
</ul>
<p>Widget plugins can be found in the <a href="powl/plugins/widget">"plugins/widget" subdirectory</a> of the pOWL distribution.</p>
<p>Please contact us if you would like to provide some other edit widget or submit a feature request.</p>

<h2>pOWL API</h2>
This API will provide classes and functions for the following topics:
<ul>
	<li>User authentication</li>
	<li>Localization</li>
	<li>Configuration</li>
	<li>Model versioning wrapper</li>
</ul>
<p>The API ist located in the <a href="powl/owlapi">"powlapi" subdirectory</a> of the pOWL distribution.</p>
<h2>Backend</h2>
<p>Ideally pOWL will be able to combine dynamically different XML, RDF, RDFS, OWL APIs.</p>
<p>Possible candidates are combined in this table:</p>
<table width="600">
<tr><th>Level of semantic pyramid</th><th colspan="8">Available APIs</th></tr>
<tr><th>XML Parser</th>
	<td><table class="blind" width="100%"><tr>
		<td><a href="http://www.wiwiss.fu-berlin.de/suhl/bizer/rdfapi">RAP</a><br />
			RDFAPI for PHP</td>
		<td><a href="http://www.php.net/manual/en/ref.simplexml.php">SimpleXML</a><br />
			part of PHP5</td>
		<td>DOM</td>
		<td>SAX</td>
	</tr></table></td>
</tr>
<tr><th>RDF API</th>
	<td><table class="blind" width="100%"><tr>
		<td><a href="http://www.wiwiss.fu-berlin.de/suhl/bizer/rdfapi/DbModel.html">RAP Mem</a><br />
			API for in memory Models provided by RAP</td>
		<td><a href="http://www.wiwiss.fu-berlin.de/suhl/bizer/rdfapi/MemModel.html">RAP DB</a><br />
			API for in DB stored Models provided by RAP</td>
		<td><a href="http://jena.sourceforge.net/">Jena</a><br />
			Semantic Web Framework for Java</td>
		<td><a href="http://jena.sourceforge.net/DB">Jena DB</a><br />
			accessing Jena DB tables directly from PHP</td>
		<td><a href="http://km.aifb.uni-karlsruhe.de/kaon2">KAON</a><br />
			KArlsruhe ONtology and Semantic Web tool suite
		<td><a href="http://km.aifb.uni-karlsruhe.de/kaon2">KAON DB</a><br />
			accessing KAON DB tables directly from PHP</td>
		<td><a href="http://www.redland.opensource.ac.uk/docs/php.html">Redland RDF Application Framework</a></td>
		<td><a href="http://www.openrdf.org/">SESAME</a></td>
	</tr></table></td>
</tr>
<tr><th>RDFS API</th>
	<td><table class="blind" width="100%"><tr>
	<td><a href="api/">pOWL-RDFS</a><br />
		integral part of pOWL (still under heavy development)</td>
	<td><a href="http://km.aifb.uni-karlsruhe.de/kaon2">KAON</a><br />
		KArlsruhe ONtology and Semantic Web tool suite
	</td>
	<td>Jena</td>
	</tr></table></td>
</tr>
<tr><th>OWL API</th>
	<td><table class="blind" width="100%"><tr>
		<td><a href="api/">pOWL-OWL</a><br />
			integral part of pOWL (in an early stage of development)</td>
		<td><a href="http://owl.man.ac.uk/api.shtml">OWL API</a><br />
			developed at the University of Manchester
		<td>Jena</td>
	</tr></table></td>
</tr>
</table>
<p>By now pOWL uses RAP DB for RDF and XML processing and pOWL's own API's for RDFS and OWL access.</p>
<p>Wrappers for these APIs will be located in the <a href="api/">"rdfapi"</a>,
<a href="api/">"rdfsapi"</a>, <a href="api/">"owlapi"</a> subdirectories
of the pOWL distribution.</p>
<p>Please contact us if you would like to provide a PHP wrapper for the other APIs.</p>
</body>
</html>