<? include('header.php'); ?>
<h1>pOWL - <i style="font-weight:normal">Semantic Web Development Plattform</i></h1>

<h2><a name="Overview"></a>Overview</h2>
<img src="images/powl-screenshot.png" style="float:right; border:solid black 1px; margin-left:5px;">

<p>The broad application of ontologies as shared terminological knowledge representations
is one of the main strategies of the semantic web paradigm. With <a href="http://www.w3.org/RDF/">RDF(S)</a> (Resource Description Framework)
and <a href="http://www.w3.org/2004/OWL/">OWL</a> (Web Ontology Language) there exist W3C standards for defining
web enabled ontologies which fit in the semantic layering of web languages.</p>

<p>Although there is a bunch of OWL ontology editing and management solutions available,
some of them are complicated to deploy or handle, some do not support strategies for collaborative,
distributed development of ontologies, some are not Open Source or not available for the most
distributed web technologies.</p>

<p>Since <a href="http://www.php.net">PHP</a> is by far the most distributed web development
technology (as regularly confirmed by <a href="http://www.netcraft.com/">Netcraft</a>), the semantic web paradigm will probably
only be successful in a broad perspective if there are applications and tools available
tightly interacting with this language. The aim of the pOWL project is thus
to deliver a PHP and web-based ontology editing and management solution to the OpenSoure community.</p>

<h2><a name="Architecture"></a>Architecture</h2>
pOWL consists of the following components:
<ul>
<li><a href="http://www.wiwiss.fu-berlin.de/suhl/bizer/rdfapi">RAP - RDF API for PHP</a> an independent project by Chris Bizer, Radoslaw Oldakowski and others (thanks here for their great work)</li>
<li><a href="api/">RDFS and OWL API for PHP</a> - integral part of pOWL</li>
<li>pOWL Webapplication framework:
	<ul>
		<li>Tabplugins, as Models, RDF-Triples, Classes, Properties, Instances<br />
			future releases may include e.g. export or visualisation plugins
		</li>

		<li>Widgetplugins for data editing<br />
			widgets for comfortable editing of WYSIWIG-HTML, Dates, Tree-Selects are planned
		</li>
	</ul>
</li>
</ul>
<p>Powl requires a PHP (greater 4.2) enabled webserver and a database backend for storing model data (MySQL, Postgres, Oracle and others - see <a href="http://phplens.com/adodb/supported.databases.html">ADODB Documentation</a> for supported RDBMS).</p>
<p>Please have a look at the planned <a href="powl/doc/architecture.php" target="_blank">pOWL architecture description</a> for details.</p>

<h2><a name="Features"></a>Features</h2>

<ul>
<li><b>POWL supports viewing, editing of RDFS/OWL ontologies of arbitrary size.</b>
It is even quite fast with the largest available models (e.g. NCI Cancer Ontology containing about 28,000 classes).</li>
<li><b>Sophisticated widgets for data editing</b> such as widgets for editing HTML in a WYSIWIG manner or for dates are integrated.</li>
<li><b>Questioning the knowledge base.</b> pOWL currently offers an RDQL query builder as well as a full-text search for literals and resources.</li>
<li><b>Plugin concept.</b> POWL is easy extensible, unfortunately still laking exhaustive documentation on this - please have a look at the
source code and pester the developers. :-)</li>
<li><b>Powerful object oriented API.</b> All functionality is accessible by a clean application programming interface.</li>
<li><b>Authentification scheme.</b> Fine grained exposition of features and model data: Privileges (view, edit)
for users and groups are planned to be assigned to Models, Classes and Properties.</li>
<li><b>Versioning.</b> All edits of a knowledge base may be logged and rolled back (depending on time, user and edit action).</li>
<li><b>POWL is fast.</b> Models are stored in database tables and only those parts of the model are loaded into
main memory which are actually needed. Thus POWL is scalable and fast.</li>
<li><b>Multi language support.</b> POWL comes with English and German translations of the user interface.
If you would like to provide a translation please contact us!</li>
<li><b>Easy deployment.</b> Just extract the pOWL distribution to a PHP enabled webspace and adjust
database connection parameters in "/etc/powl.conf".</li></ul>
You miss a feature? Please submit a feature request at the <a href="http://sourceforge.net/projects/powl">Sourceforge Project Page</a>.

<? include('footer.php'); ?>