<?
/**
 * RDFS-class viewer and editor.
 *
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: restriction.php,v 1.17 2006/01/31 19:01:13 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();

$property=$_ET['rdfsmodel']->getProperty($_REQUEST['property']);
$class=$_ET['rdfsmodel']->getClass($_REQUEST['class']);
if($res=parray_shift($class->getRestrictionAllValuesFrom($property)))
	$type='allValuesFrom';
else if($res=parray_shift($class->getRestrictionSomeValuesFrom($property)))
	$type='someValuesFrom';
else if($res=parray_shift($class->getRestrictionHasValue($property)))
	$type='hasValue';
else {
	$res=new Resource('');
	$type='';
}
if(!is_a($res,'Resource'))
	$res=$res->obj;
if($_POST) {
	// reuse existing restriction
	if($stm=$class->_getRestrictionStatement($property)) {
		$class->model->logStart('Restriction changed','Class - '.$class->getLocalName().', Property - '.$property->getLocalName(),$_POST['versioningDetails']);
		$class->model->remove($stm);
		$subj=$stm->subj;
		if(isBNode($res))
			$res->remove();
	} else { // create new
		$class->model->logStart('Restriction added','Class - '.$class->getLocalName().', Property - '.$property->getLocalName(),$_POST['versioningDetails']);
		$subj=new BlankNode($class->model->getUniqueResourceURI(BNODE_PREFIX));
		$class->model->add($class,$GLOBALS['RDFS_subClassOf'],$subj);
		$class->model->add($subj,$GLOBALS['RDF_type'],$GLOBALS['OWL_Restriction']);
		$class->model->add($subj,$GLOBALS['OWL_onProperty'],$property);
	}
	if($_POST['type']=='hasValue') {
		if($property->isDatatypeProperty())
			$obj=new Literal($_POST['literal']);
		else
			$obj=$_POST['individual'];
	} else {
		$_POST['resource']=array_unique(array_filter($_POST['resource']));
		if($property->isDatatypeProperty())
			$obj=$_POST['datarange'];
		else if(count($_POST['resource'])) {
			if(count($_POST['resource'])==1)
				$obj=$_POST['resource'][0];
			else if(!$_POST['delete']) {
				$oneOf=$class->model->addList($_POST['resource'],false);
				$obj=new BlankNode($class->model->getUniqueResourceURI(BNODE_PREFIX));
				$class->model->add($obj,$GLOBALS['OWL_oneOf'],$oneOf);
				$class->model->add($obj,$GLOBALS['RDF_type'],$GLOBALS['OWL_Class']);
			}
		}
	}
#print_r($obj);
#exit;
	if($_POST[delete]) {
		$class->model->logStart('Restriction removed','Class - '.$class->getLocalName().', Property - '.$property->getLocalName(),$_POST['versioningDetails']);
		$del=$class->model->resourceF($subj->getURI());
		$del->remove();
	} else if($obj)
		$class->model->add($subj,$GLOBALS['OWL_'.$_POST['type']],$obj);
	echo('<script language="javascript">opener.location.href=opener.location.href+\'&rel\';close();</script>');
	exit;
}
$t=new text(array('Attributes'=>'readonly="readonly"','cardinality'=>1));
if(!$powl->aclCheck('Edit',$_ET['rdfsmodel']))
	pwlDeny();
?>
<h1>Edit Restriction</h1>
<form method="post">
<p><b>For Property:</b><br />
<?=$t->edit('property',$property->getLocalname())?></p>
<p><b>At Class:</b><br />
<?=$t->edit('class',$class->getLocalName())?></p>
<script language="javascript">powl.SafeAddOnload(function() { powl.formOptions('target'); });</script>
<?
$s=new select(array('cardinality'=>1));
echo('<p><b>Type:</b><br />'.$s->edit('type',$type,array('allValuesFrom'=>'allValuesFrom','someValuesFrom'=>'someValuesFrom','hasValue'=>'hasValue')).'</p>');

echo('<div id="typeDefault">');
$s=new select(array('cardinality'=>1));
$r=new selectResource();
if($property->isDatatypeProperty())
	echo('<p>Data range:<br />'.$s->edit('datarange',is_a($res,'Resource')?$res->getURI():'',$_POWL['datatypes']).'</p>');
else
	echo('<p>Class description:<br />'.$r->edit('resource',(!isBnode($res)?$res->getLocalName():array_keys($class->model->getOneOf($res)))).'</p>');
echo('</div>');

$r=new selectResource(array('cardinalityMax'=>1));
$t=new text(array('cardinality'=>1));

echo('<div id="hasValue">');
if($property->isDatatypeProperty())
	echo('<p>Literal:<br />'.$t->edit('literal',is_a($res,'Literal')?$res->getLabel():'').'</p>');
else
	echo('<p>Resource:<br />'.$r->edit('individual',$type=='hasValue' && !is_a($res,'Literal')?$res->getLocalName():'').'</p>');

if((is_a($res,'Resource') && $res->getURI()) || is_a($res,'Literal'))
	echo('<p><input type="checkbox" name="delete"> Delete Restriction</p>');
?>
</div>
<p>
<input type="checkbox" name="versioningComment" onchange="powl.formOptions(this)" value="versioningComment" /> <?=pwl_('Versioning comment')?>
<div id="versioningComment" style="display:none; margin-top:-10px;">
<textarea name="versioningDetails"></textarea>
</div>
</p>
<br />
<input type="submit" value="<?=pwl_('Submit')?>" onclick="powl.wait(this)"></form>
<? pwlHTMLFooter(); ?>