<?php
//
// +----------------------------------------------------------------------+
// | GeoClass                                                             |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 multimediamotz, Stefan Motz                       |
// +----------------------------------------------------------------------+
// | License (LGPL)                                                       |
// | This library is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU Lesser General Public           |
// | License as published by the Free Software Foundation; either         |
// | version 2.1 of the License, or (at your option) any later version.   |
// +----------------------------------------------------------------------+
// | This library is distributed in the hope that it will be useful,      |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     |
// | Lesser General Public License for more details.                      |
// +----------------------------------------------------------------------+
// | You should have received a copy of the GNU Lesser General Public     |
// | License along with this library; if not, write to the Free Software  |
// | Foundation Inc., 59 Temple Place,Suite 330, Boston,MA 02111-1307 USA |
// +----------------------------------------------------------------------+
// | Authors:  Stefan Motz   <stefan@multimediamotz.de>                   |
// |           Arne Klempert <arne@klempert.de>                           |
// | Version:  0.2.1                                                      |
// | Homepage: http://geoclassphp.sourceforge.net                         |
// +----------------------------------------------------------------------+
//
// $Id: DB_OpenGeoDB.php,v 1.1 2003/09/15 17:44:12 klempert Exp $

require_once "Geo/sources/DB.php";

/**
 * Geo_OpenGeoDB
 *
 * @access   public
 * @package  Geo
 */
class Geo_OpenGeoDB extends Geo_DB {

    /**
     * some options
     *
     * @var  array    options
     */
    var $options = array(
        'language' => 'en',
        'table' => 'geodb_locations',
        'fields' => array(
            'name' => 'name',
            'longitude' => 'laenge',
            'latitude' => 'breite',
        ),
        'order' => 'name_int',
        'degree' => true,
        'unit' => GEO_UNIT_DEFAULT,
    );

    /**
     * constructor Geo_OpenGeoDB
     *
     * @var		string	$dsn
     * @var		array	$options
     * @return	void
     */
    function Geo_OpenGeoDB($dsn, $options=array()) {
        $this->_connectDB($dsn);
        $this->setOptions($options);
    }

}
?>
