<?
/**
 * RDFS-instance viewer and editor.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: instance.php,v 1.78 2005/02/16 23:28:17 soerenauer Exp $
 **/
@include_once('../../include.php');

$isNew=false;
if(!empty($_REQUEST['uri'])) {
	if(!$instance=$_ET['rdfsmodel']->getInstance($_REQUEST['uri'])) {
		$instance=new $_ET['rdfsmodel']->instance($_REQUEST['uri'],$_ET['rdfsmodel']);
		$isNew=true;
	}
	if(empty($_REQUEST["class"]) || !$class=$_ET['rdfsmodel']->getClass($_REQUEST["class"]))
		$class=$instance->getClass();
} else {
	$isNew=true;
	$class=$_ET['rdfsmodel']->getClass($_REQUEST["class"]);
	$instance=new $_ET['rdfsmodel']->instance(empty($_REQUEST['name'])?$_ET['rdfsmodel']->getUniqueResourceURI('Instance'):$_REQUEST['name'],$class->model,$_ET['rdfsmodel']);
}

$editable=$powl->aclCheck('Edit',$_ET['rdfsmodel'])&&(!$instance->isImported()||$isNew)?true:false;
pwlHTMLHeader(($isNew?'Create New':($editable?'Edit':'View'))." Instance");

if($_SERVER['REQUEST_METHOD']=='POST') {
	if(!$editable)
		pwlDeny();
	// new instance for class
	if($_REQUEST['name'] && !$_REQUEST['uri']) {
		$instance->model->logStart('Instance added',$instance->getLocalName(),$_POST['versioningDetails']);
		$class->addInstance($_REQUEST['name']);
		echo('<script language="javascript">if(parent.frames[\'instance\']) parent.frames[\'details\'].location.reload();</script>');
	} else {
		if($_REQUEST['name']!=$instance->getLocalName())
			$instance->rename($_REQUEST['name']);
		$instance->model->logStart('Instance changed',$instance->getLocalName(),$_POST['versioningDetails']);
	}
	$instance->setClass($_REQUEST['class']);
	// save new/modified properties
	if(!empty($_POST['prop']) && $p=$class->listProperties()) {
		foreach($p as $cl)
			foreach($cl as $prop) {	
				if(empty($_POST['prop'][$prop->getURI()]))
					$instance->removePropertyValues($prop);
				else if(is_array($_POST['prop'][$prop->getURI()])) {
					$newPropertyValues=array_filter($_POST['prop'][$prop->getURI()]);
					$oldPropertyValues=$instance->listPropertyValuesPlain($prop);
					foreach(array_diff($oldPropertyValues,$newPropertyValues) as $removed)
						$instance->removePropertyValues($prop,$removed);
					foreach(array_diff($newPropertyValues,$oldPropertyValues) as $added)
						$instance->addPropertyValue($prop,$added);
				} else if($instance->getPropertyValuePlain($prop)!=$_POST['prop'][$prop->getURI()])
					$instance->setPropertyValue($prop,$_POST['prop'][$prop->getURI()]);										
			}
	}
	// save metainformations for instance
	pwlResourceMetaProcess($instance);
	echo('<script language="javascript">if(opener) {opener.location.reload(); close(); }</script>');
}

if(!empty($_REQUEST['action']) && $_REQUEST['action']=='remove') {
	if(!$editable)
		pwlDeny();
	$instance->model->logStart('Instance removed',$instance->getLocalName(),$_POST['versioningDetails']);
	$instance->remove();
	echo('<script language="javascript">parent.frames[\'details\'].location.reload();document.location.href="instance.php?class='.urlencode($_REQUEST['class']).'";</script>');
}
?>
<form method="POST" name="instance">
<input type="hidden" name="action" value="" />
<input type="hidden" name="uri" value="<?=$isNew?'':$instance->getLocalName()?>" />
<input type="text" name="name" value="<?=$instance->getLocalName()?>" style="font-weight:bold; width:400px;" <?=$editable?'':' readonly="readonly"'?>>
<p><b>Instance of:</b><br/>
<?
$sConfig=array('cardinalityMax'=>1);
if(!$editable)
	$sConfig['readonly']=true;
$s=new selectClass($sConfig);
echo($s->edit('class',$class->getLocalName()));
?></p>
<h2><?=pwlHTMLOptional('props','instance')?><img src="../../images/Properties.gif" align="absmiddle">&nbsp;<?= pwl_("Properties") ?></h2>
<div id="props">
<input id="showUsedPropertiesC" type="checkbox" onclick="u=powl.getState('instance','showUsedProperties'); powl.setState('instance','showUsedProperties',u?!u:true);
	showUsedProperties()">&nbsp;Show only used properties (by <?=checkbox::edit('showUsedPropertiesThisall','',array('this'=>'this','all'=>'all'),array('cardinality'=>1,'Attributes'=>'onclick="powl.setState(\'instance\',\'showUsedPropertiesThisall\',this.value); showUsedProperties();"'))?>&nbsp;&nbsp;&nbsp;Instances)<script language="javascript">
var used=new Array;
<?
foreach($class->listPropertiesUsed() as $p)
	echo('used[\'prop['.$p->getURI().'][]\']=true;');
?>
function showUsedProperties() {
	e=document.forms['instance'].elements;
	s=document.getElementsByName('showUsedPropertiesThisall');
	v=document.getElementById('showUsedPropertiesC').checked?'none':'';
	for(var i in e)
		if(e[i].name && e[i].name.match(/prop/)) {
			if(s[1].checked) {
				if(!used[e[i].name])
					powl.setVisibility('tr'+e[i].name,v);
				else
					powl.setVisibility('tr'+e[i].name,'');
			} else if(s[0].checked ) {
				if(!e[i].value)
					powl.setVisibility('tr'+e[i].name,v);
				else
					powl.setVisibility('tr'+e[i].name,'');
			} else
				powl.setVisibility('tr'+e[i].name,'');
		}
}
if(powl.getState('instance','showUsedPropertiesThisall')=='this')
	document.getElementsByName('showUsedPropertiesThisall')[0].checked=true;
else
	document.getElementsByName('showUsedPropertiesThisall')[1].checked=true;
if(powl.getState('instance','showUsedProperties')) {
	document.getElementById('showUsedPropertiesC').checked=true;
	powl.SafeAddOnload(function(){showUsedProperties();});
}
</script>
<table>
<tr><th><?= pwl_("Name") ?></th><th><?= pwl_("Value") ?></th></tr>
<?
if($p=$isNew?$class->listProperties():$instance->listProperties()) {
	$i=0;
	foreach($p as $cl)
		foreach($cl as $prop) {
			$propertyValue=empty($_REQUEST['uri'])?'':$instance->listPropertyValuesPlain($prop);
			$label=$prop->getLabelForLanguage($_SESSION['PWL']['language'])?$prop->getLabelForLanguage($_SESSION['PWL']['language']):($prop->getLabelForLanguage('en')?$prop->getLabelForLanguage('en'):$prop->getLocalName());
			$label=$prop->getLabelForLanguage()?$prop->getLabelForLanguage():$label;
			$comment=$prop->getComment($_SESSION['PWL']['language'])?$prop->getComment($_SESSION['PWL']['language']):$prop->getComment('en');
			$comment=$comment?$comment:$prop->getComment();
			echo('<tbody id="trprop['.$prop->getURI().'][]"><tr'.($i++%2==0?' class="even"':'').'><td align="right" nowrap="nowrap" valign="top">'.pwlHTMLOptional('prop'.$prop->getLocalName(),'instance','').'&nbsp;'.
				($comment?'&nbsp;<span title="'.$comment->getLabel().'" class="help">'.$label.'</span>':$label).'</td><td><div id="prop'.$prop->getLocalName().'">'.
			     pwlGetWidget($class,$prop,$propertyValue?$propertyValue:(empty($_REQUEST['uri']) && !empty($_GET[$prop->getLocalName()])?$_GET[$prop->getLocalName()]:'')).
				 '</div></td></tr></tbody>');
		}
}
if($i==0)
	echo('<tr><td colspan="2">'.pwl_("No properties defined yet").'</tr>');
?>
</table>
</div>
<?=pwlResourceMetaShow($instance,true,$editable) ?>
<br />
<? if($editable) { ?>
<?=pwlResourceVersioning($instance)?><br />
<INPUT type="submit" value="<?=pwl_($isNew?'Create':'Save changes')?>" onclick="powl.wait(this)"/>
<? } ?>
</form>
<? pwlHTMLFooter(); ?>