<?
/**
 * Creates an ontology model in human readable format.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: export_html.php,v 1.1 2004/11/22 22:03:13 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();
?>
<link rel="stylesheet" type="text/css" href="http://www.w3.org/StyleSheets/TR/W3C-REC" />
<style type="text/css">
h3.class {
	background: transparent url('../../images/Classes.gif') 0% 50% no-repeat;
	padding-left: 30px;
	white-space: nowrap;
}
h3.property {
	background: transparent url('../../images/Properties.gif') 0% 50% no-repeat;
	padding-left: 30px;
	white-space: nowrap;
}
h3.instance {
	background: transparent url('../../images/Instances.gif') 0% 50% no-repeat;
	padding-left: 30px;
	white-space: nowrap;
}
</style>
<h1>Ontology: <?=$_ET['rdfsmodel']->modelURI?></h1>
<?=nl2br($_ET['rdfsmodel']->asResource->getComment())?>
<ul>
<li><a href="#classes">Classes</a></li>
<li><a href="#properties">Properties</a></li>
<li><a href="#instances">Instances</a></li>
</ul>
<h2><a name="classes"></a>Classes</h2>
<ul class="classesOverview">
<?
foreach($_ET['rdfsmodel']->listTopClasses() as $val)
	echo('<li><a href="#'.$val->getLocalName().'">'.$val->getLocalName().'</a></li>');
echo('</ul>');
function pwlShowMeta($resource) {
	$ret='';
	foreach($resource->listComments() as $comment)
		$ret.='<p><b>'.$comment->getLanguage().':</b> '.$comment->getLabel().'</p>';
	if($labels=$resource->listLabels()) {
		$ret.='<h4>Labels</h4>';
		foreach($labels as $label)
			$ret.=($lang=$label->getLanguage()?$lang.': ':'').$label->getLabel().'<br />';
	}
	$a='';
	foreach($resource->model->listAnnotationProperties(true) as $annotationProperty)
		foreach($resource->listPropertyValues($annotationProperty) as $annotationValue)
			$a.=$annotationProperty->getLocalName().': '.$annotationValue->getLabel().'<br />';
	$ret.=$a?'<h4>Annotations</h4>'.$a:'';
	return $ret;
}
foreach($_ET['rdfsmodel']->listClasses() as $val) {
	echo('<h3 class="class"><a name="'.$val->getLocalName().'"></a>'.$val->getLocalName().'</h3>'.
		pwlShowMeta($val)
	);
	echo('<h4>Superclasses</h4><ul>');
	if($subclasses=$val->listSuperClasses())
		foreach($subclasses as $val1)
			echo('<li><a href="#'.$val1->getLocalName().'">'.$val1->getLocalName().'</a></li>');
	else echo('<li>No superclasses</li>');
	echo('</ul><h4>Subclasses</h4><ul>');
	if($subclasses=$val->listSubClasses())
		foreach($subclasses as $val1)
			echo('<li><a href="#'.$val1->getLocalName().'">'.$val1->getLocalName().'</a></li>');
	else echo('<li>No subclasses</li>');
	echo('</ul><h4>Properties</h4><ul>');
	if($properties=$val->listProperties())
		foreach($properties as $val2)
			foreach($val2 as $val1)
				echo('<li><a href="#'.$val1->getLocalName().'">'.$val1->getLocalName().'</a></li>');
	else echo('<li>No properties</li>');
	echo('</ul><h4>Instances</h4><ul>');
	if($instances=$val->listInstances())
		foreach($instances as $val1)
			echo('<li><a href="#'.$val1->getLocalName().'">'.$val1->getLocalName().'</a></li>');
	else echo('<li>No instances</li>');
	echo('</ul>');
	echo('<a href="#top">TOP</a> | <a href="#classes">Classes</a> | <a href="#properties">Properties</a> | <a href="#instances">Instances');
}
?>
<h2><a name="properties"></a>Properties</h2>
<ul class="propertiesOverview">
<?
foreach($_ET['rdfsmodel']->listTopProperties() as $val)
	echo('<li><a href="#'.$val->getLocalName().'">'.$val->getLocalName().'</a></li>');
echo('</ul>');
foreach($_ET['rdfsmodel']->listTopProperties() as $val) {
	echo('<h3 class="property"><a name="'.$val->getLocalName().'"></a>'.$val->getLocalName().'</h3>');
	echo('<h4>Subproperties</h4><ul>');
	if($subclasses=$val->listSubproperties())
		foreach($subclasses as $val1)
			echo('<li><a href="#'.$val1->getLocalName().'">'.$val1->getLocalName().'</a></li>');
	else echo('<li>No subproperties</li>');
	echo('</ul><h4>Domain</h4><ul>');
	foreach($val->listDomain() as $val1)
		echo('<li><a href="#'.$val1->getLocalName().'">'.$val1->getLocalName().'</a></li>');
	echo('</ul><h4>Range</h4><p>');
	if(!$ranges=$val->listRange())
		echo('Not defined');
	else
		echo(join(',',array_keys($ranges)));
	echo('</p><a href="#top">TOP</a> | <a href="#classes">Classes</a> | <a href="#properties">Properties</a> | <a href="#instances">Instances');
}
?>
<h2><a name="instances"></a>Instances</h2>
<?
foreach($_ET['rdfsmodel']->listInstances() as $val) {
	echo('<h3><a name="'.$val->getLocalName().'"></a>'.$val->getLocalName().'</h3>');
}
pwlHTMLFooter();
?>