<?
/**
 * create and edit RDFS-models.
 *
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: model_add.php,v 1.1 2006/02/18 17:49:20 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();
?>
<h2><?= pwl_("Create/import/edit model") ?></h2>
<?
if(!$powl->aclCheck('AddModels'))
	pwlDeny();
if($_POST) {
	if(!$_REQUEST['model'])
		echo(pwl_('Please supply a model URI!'));
	else if($powl->getModel($_REQUEST['model']))
		echo(pwl_('A model with this model URI already exists!'));
	else {
		// create empty model
		if(!$m && !empty($_REQUEST['create']) && $_REQUEST['create']=='empty') {
			$m=$powl->getNewModel($_POST['model'],$_POST['baseURI'],$_REQUEST['type']?$_REQUEST['type']:'RDF');
		}
		// update model metadata
		if($m) {
			$m->setBaseURI($_POST['baseURI']);
			if($_REQUEST['type']=='OWL')
				$m->setType($_REQUEST['type']);
		} else { // load model from file
			if($_REQUEST['create']=='paste') {
				$file=tempnam('/tmp','powl');
				$temp=fopen($file,'wb');
				fwrite($temp,$_REQUEST['paste']);
				fclose($temp);
			} else if($_REQUEST['create']=='upload')
				$file=$_FILES['source']['tmp_name'];
			else
				$file=$_REQUEST['alternativeLocation']?$_REQUEST['location']:$_REQUEST['model'];
			$m=$powl->loadModel($_POST['model'],$file,$_REQUEST['loadImports']);
			if($_REQUEST['create']=='paste')
				unlink($file);
		}
		if($GLOBALS['_POWL']['SysOnt'] && $user=$GLOBALS['_POWL']['SysOnt']->getInstance($_SESSION['PWL']['user']))
			$user->addPropertyValue('userModelsEdit',$m->modelURI);
		if($_FILES['source']['error']==1)
			echo('<b>'.pwl_('Upload Error:').'</b> '.pwl_('File size exceeds php configuration value "upload_max_filesize"!'));
		else if($_FILES['source']['error']==3)
			echo('<b>'.pwl_('Upload Error:').'</b> '.pwl_('File was only partialy uploaded. Please try again!'));
		else {
			if(empty($GLOBALS['_POWL']['errors']))
				echo('<script language="javascript">powl.reloadGET(opener.top.frames[\'top\'],opener);close();</script>');
			else echo('<input value="Close" type="button" onclick="powl.reloadGET(opener.top.frames[\'top\'],opener);window.close();" />');
			exit;
		}
	}
}
?>
<form method="post" enctype="multipart/form-data">
<p><b><?= pwl_("Model URI:") ?></b><br />
<input type="text" name="model" value="<?=!empty($m->modelURI)?$m->modelURI:''?>" style="width:95%;"/></p>
<script language="javascript">powl.SafeAddOnload(function() { powl.formOptions('create'); });</script>
<input type="radio" name="create" value="empty" onclick="powl.formOptions(this)">&nbsp;<b><?= pwl_("Create empty model") ?></b>
<div id="empty" style="margin-left:25px;">
<p style="margin:0px;"><?= pwl_("Base URI:") ?><br />
<input type="text" name="baseURI" value="<?=!empty($m->baseURI)?$m->baseURI:''?>" style="width:95%;"/></p>
<p style="margin:0px;"><?=pwl_('Type:');?><br /><?
$s=new select(array('cardinalityMax'=>1,'cardinalityMin'=>1));
echo($s->edit('type',$m?$m->getType():'RDFS',array('RDFS'=>'RDF(S)','OWL'=>'OWL')));
$t=new text(array('AttributeStyle'=>'width:90%;'));
$ts=new textselect(array('AttributeStyle'=>'width:90%;'));
?></p>
</div>
<br />
<? if(ini_get('allow_url_fopen')) { ?>
<input type="radio" name="create" value="import" onclick="powl.formOptions(this)" checked />&nbsp;<b><?= pwl_('Import from the Web') ?></b><br />
<div id="import" style="margin-left:25px;">
<?=pwl_('Download from modelURI or')?><br />
<input type="checkbox" name="alternativeLocation" onclick="powl.formOptions(this)" />&nbsp;<?= pwl_('Use alternative location:') ?><br />
	<div id="modelURI" style="margin-left:25px;">
		<input type="text" name="location" style="width:95%;" />
	</div>
</div>
<input type="radio" name="create" value="upload" onclick="powl.formOptions(this)" />&nbsp;<b><?= pwl_('Upload from file') ?></b><br />
<div id="upload" style="margin-left:25px;">
<p><?=pwl_('File type:')?><br />
<?=$s->edit('filetype','',array(''=>'Autodetect','rdf'=>'RDF/XML','n3'=>'N3','nt'=>'N-Triples'))?></p>
<p><?=pwl_('File:')?><br />
<input type="file" name="source" /><br />
(Max. <?=ini_get('upload_max_filesize')?>)</p>
</div>
<input type="radio" name="create" value="paste" onclick="powl.formOptions(this)" />&nbsp;<b><?= pwl_('Paste source') ?></b>
<div id="paste" style="margin-left:25px;">
<textarea name="paste" style="width:95%; height:200px;" /></textarea>
</div>
<p><input type="checkbox" name="loadImports" value="1" <?=ini_get('allow_url_fopen')?'':'disabled'?>/> Automatically load owl:imports</p>
<? } ?>
<input type="submit" value="<?=pwl_('Submit')?>" onclick="powl.wait(this)" />
</form>
<? pwlHTMLFooter(); ?>
