<?
/**
 * RDF triple viewer.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: source.php,v 1.14 2004/11/22 22:03:16 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();

?>
<h1><?= pwl_("RDF Source") ?></h1>
<? if(empty($_ET['rdfsmodel'])) {
	echo(pwl_('<b>No model selected.</b><br/>Please select a model first!').'</body>');
	pwlHTMLFooter();
	exit;
}

$resource=$GLOBALS['_ET']['rdfsmodel']->resourceF($_REQUEST['uri']);
$m=$resource->getDefiningModel(empty($_REQUEST['includeSubClasses'])?false:true,empty($_REQUEST['includeProperties'])?false:true,empty($_REQUEST['includeInstances'])?false:true);
#foreach($m->triples as $t)
#	print_r($t->subj->getURI().$t->pred->getURI().'<br>');
require_once(RDFAPI_INCLUDE_DIR.PACKAGE_SYNTAX_RDF);
require_once(RDFAPI_INCLUDE_DIR.PACKAGE_SYNTAX_N3);

$type=empty($_REQUEST['type'])?'RDF':$_REQUEST['type'];
$s=$type.'Serializer';
$serializer=new $s();

if($_POST['source']) {
	$p=$type.'Parser';
	$parser=new $p();
	if(!$powl->aclCheck('Edit',$_ET['rdfsmodel']))
		pwlDeny();
	$_ET['rdfsmodel']->logStart('RDF source changed',$_REQUEST[uri],$_POST['versioningDetails']);
	$n=$parser->generateModel($_POST['source']);
	$_ET['rdfsmodel']->addModel($n->subtract($m));
	$m->addModel($n->subtract($m));
	$del=$m->subtract($n);
	$m=$m->subtract($del);
	foreach($del->triples as $t)
		$_ET['rdfsmodel']->remove($t);
}

$source=&$serializer->serialize($m);

$done=true;
while($done) {
	$done=false;
	preg_match_all('/(\s*)<([^>]+)( rdf:nodeID="([^"]+)"\/)>/',$source,$bn);
	foreach($bn[0] as $key=>$tag) {
		if(!$bn[3][$key])
			continue;
		preg_match('/(\s*)<([^ >]+)( rdf:nodeID="('.preg_quote($bn[4][$key],'/').')")>.*\\1<\/\\2>/imsU',$source,$bne);
		if(!$bne[3])
			continue;
		$done=true;
		$source=str_replace($bn[3][$key],">".str_replace("\n",$bn[1][$key].INDENTATION,
						str_replace($bne[3],'',$bne[0])
					).$bn[1][$key].'</'.$bn[2][$key],
				str_replace($bne[0],'',$source)
			);
		break;
	}
}
$source=preg_replace('/\n\n\n+/',"\n\n",$source);

preg_match_all('/xmlns:(ns[0-9]+)="([^"]+)"/',$source,$ns);
foreach($ns[2] as $key=>$n) {
	if($s=array_search($n,$default_prefixes)) {
		$source=str_replace('xmlns:'.$ns[1][$key].'="','xmlns:'.$s.'="',$source);
		$source=str_replace('<'.$ns[1][$key].':','<'.$s.':',$source);
		$source=str_replace('</'.$ns[1][$key].':','</'.$s.':',$source);
	}
}
?>
<form method="post">
<input type="hidden" name="uri" value="<?=$_REQUEST['uri']?>" />
<?
echo(checkbox::edit('type',$_REQUEST['type'],array(''=>'RDF','N3'=>'N3','NTriple'=>'NTriple'),array('cardinalityMax'=>1,'Attributes'=>'onclick="this.form.submit()"')).'<br />');

if($GLOBALS['_ET']['rdfsmodel']->getClass($_REQUEST['uri'])) { ?>
<input onclick="this.form.submit()" type="checkbox" name="includeSubClasses" <?=!empty($_REQUEST['includeSubClasses'])?'checked':''?> /> include sub-classes&nbsp;&nbsp;&nbsp;
<input onclick="this.form.submit()" type="checkbox" name="includeProperties" <?=!empty($_REQUEST['includeProperties'])?'checked':''?> /> include properties&nbsp;&nbsp;&nbsp;
<input onclick="this.form.submit()" type="checkbox" name="includeInstances" <?=!empty($_REQUEST['includeInstances'])?'checked':''?> /> include instances<br />
<? } ?>
</form>
<form method="post">
<input type="hidden" name="uri" value="<?=$_REQUEST['uri']?>" />
<input type="hidden" name="includeSubClasses" value="<?=!empty($_REQUEST['includeSubClasses'])?$_REQUEST['includeSubClasses']:''?>" />
<input type="hidden" name="includeProperties" value="<?=!empty($_REQUEST['includeProperties'])?$_REQUEST['includeProperties']:''?>" />
<input type="hidden" name="includeInstances" value="<?=!empty($_REQUEST['includeInstances'])?$_REQUEST['includeInstances']:''?>" />
<textarea name="source" wrap="off" style="width:90%;height:500px;"<?=$powl->aclCheck('Edit',$_ET['rdfsmodel'])?'':'readonly="readonly"'?>><?=$source?></textarea><br />
<? if($powl->aclCheck('Edit',$_ET['rdfsmodel']) && !strstr($_REQUEST['uri'],':') && !strstr($_REQUEST['uri'],'#')) { ?>
<?=pwlResourceVersioning($instance)?>
<br />
<input type="submit" value="<?=pwl_('Submit')?>" onclick="powl.wait(this)" />
<? } ?>
</form>
<? pwlHTMLFooter(); ?>