<?
/**
 * RDQL Query Interface
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: index.php,v 1.13 2004/11/22 22:03:16 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();
if(!empty($_REQUEST['querytype'])) {
	if($_REQUEST['querytype']=='free')
		$query=$_REQUEST['query'];
	else if($_REQUEST['querytype']=='form') {
		$query="SELECT\n\t".$_REQUEST['select']."\nWHERE\n";
		$subjects=array_filter($_REQUEST['subject']);
		if(!empty($subjects))
			foreach($subjects as $key=>$subject)
				$query.="\t(".$_REQUEST['subject'][$key].",".$_REQUEST['predicate'][$key].",".
					(!empty($_REQUEST['object_is'][$key])?'"'.$_REQUEST['object'][$key].'"'.
						(!empty($_REQUEST['language'][$key])?'@'.$_REQUEST['language'][$key]:'').
						(!empty($_REQUEST['dtype'][$key])?'^^<'.$_REQUEST['dtype'][$key].'>':''):$_REQUEST['object'][$key]).")\n";
		$nsprefix=array_filter($_REQUEST['nsprefix']);
		$query.=!empty($_REQUEST['and'])?"AND\n\t".$_REQUEST['and']."\n":'';
		if(!empty($nsprefix)) {
			$query.="USING\n";
			foreach($nsprefix as $key=>$prefix)
				$query.="\t".$_REQUEST['nsprefix'][$key]." FOR ".$_REQUEST['nsuri'][$key]."\n";
		}
	} else {
		$instance=pwlGetSysOntInstance($_REQUEST['savedQuery']);
		$query=$instance->getPropertyValuePlain('rdqlQueryText');
	}
	if(!empty($_REQUEST['rdqlQueryTitle'])) {
		$class=pwlGetSysOntClass('RDQLQuery');
		if($insts=$class->findInstances(array($GLOBALS['_POWL']['SysOnt']->baseURI.'rdqlQueryTitle'=>$_REQUEST['rdqlQueryTitle'])))
			$instance=$insts[0];
		else
			$instance=$GLOBALS['_POWL']['SysOnt']->addInstance($GLOBALS['_POWL']['SysOnt']->getUniqueResourceURI('RDQLQuery'),$class);
		$instance->setPropertyValue('rdqlQueryTitle',$_REQUEST['rdqlQueryTitle']);
		$instance->setPropertyValue('rdqlQueryText',$query);
	}
} else
	$query="SELECT\n\t*\nWHERE\n\t(?x, rdfs:SubClassOf, ?y)\nUSING\n\trdfs FOR <http://www.w3.org/2000/01/rdf-schema#>";
?>
<h1><?= pwl_("RDQL Query") ?></h1>
<? if(empty($_ET['rdfsmodel'])) {
	echo(pwl_('<b>No model selected.</b><br/>Please select a model first!').'</body>');
	pwlHTMLFooter();
	exit;
} ?>
<form>
<?
foreach($_ET['rdfsmodel']->listNamespaces() as $n)
	$namespaces[$n]=$n;
$c=new checkbox(array('cardinality'=>1,'cols'=>'','separator'=>'&nbsp;&nbsp;&nbsp;'));
echo($c->edit('querytype',!empty($_REQUEST['querytype'])?$_REQUEST['querytype']:'form',array('form'=>'Form query','free'=>'Free query','saved'=>'Saved query')));
?>
<div id="free">
<textarea name="query" style="width:400px;height:150px;"><?=$query?></textarea><br />
Save query as:<br />
<input type="text" name="rdqlQueryTitle" />
</div>
<div id="form" style="border:solid black 1px;">
<table class="blind" style="width:500px;"><tr><td>
<b>SELECT</b>
<div style="margin-left:20px;">
<input style="width:220px;" type="text" name="select" value="<?=!empty($_REQUEST['select'])?$_REQUEST['select']:'*'?>"/>
</div>
</td><td>
<b>FROM</b>
<div style="margin-left:20px;">
<?=$_ET['rdfsmodel']->modelURI?>
</div>
</td></tr></table>
<b>WHERE</b>
<div style="margin-left:20px;">
<?
if(empty($_REQUEST['subject'])) {
	$_REQUEST['subject']=array(0=>'?x');
	$_REQUEST['predicate']=array(0=>'rdfs:SubClassOf');
	$_REQUEST['object']=array(0=>'?y');
}
$s=new select(array('cardinality'=>1));
foreach($_ET['rdfsmodel']->listDatatypes() as $dtype)
	$dtypes[$dtype]=!empty($_POWL['datatypes'][$dtype])?$_POWL['datatypes'][$dtype]:'';
$dtypes['']='Datatype';
foreach($_ET['rdfsmodel']->listLanguages() as $lang)
	$languages[$lang]=$lang;
$languages['']='Language';
foreach($_REQUEST['subject'] as $key=>$subject) { ?>
<div name="where">
<table class="blind"><tr><td valign="top">
<input onclick="inp=this" type="text" name="subject[]" value="<?=!empty($_REQUEST['subject'][$key])?$_REQUEST['subject'][$key]:''?>"/><a href="javascript:powl.winopen('resources.php?col=Subject','resources','width=300,height=500')">[s]</a>
</td><td valign="top">
<input onclick="inp=this" type="text" name="predicate[]" value="<?=!empty($_REQUEST['predicate'][$key])?$_REQUEST['predicate'][$key]:''?>"/><a href="javascript:powl.winopen('resources.php?col=Predicate','resources','width=300,height=500')">[s]</a>
</td><td valign="top">
<input onclick="inp=this" type="text" name="object[]" value="<?=!empty($_REQUEST['object'][$key])?str_replace('"','&quot;',$_REQUEST['object'][$key]):''?>"/><a href="javascript:powl.winopen('resources.php?col=Object','resources','width=300,height=500')">[s]</a><br />
<input type="checkbox" name="object_is[]" value="l" <?=!empty($_REQUEST['object_is'][$key])?'checked ':''?>onchange="if(this.checked) powl.setVisibility(this.nextSibling.nextSibling,'block'); else powl.setVisibility(this.nextSibling.nextSibling,'none');" /> Literal
<div<?=empty($_REQUEST['object_is'][$key])?' style="display:none"':''?>>
<?=$s->edit('dtype[]',!empty($_REQUEST['dtype'][$key])?$_REQUEST['dtype'][$key]:'',$dtypes)?>
<?=$s->edit('language[]',!empty($_REQUEST['language'][$key])?$_REQUEST['language'][$key]:'',$languages)?>
</div>
</td></tr></table>
</div>
<? } ?>
<a href="javascript:powl.duplicate('where')" title="Add">[+]</a>
</div>
<b>AND</b>
<div style="margin-left:20px;"><input style="width:470px;" type="text" name="and" value="<?=!empty($_REQUEST['and'])?str_replace('"','&quot;',$_REQUEST['and']):''?>"/></div>
<b>USING</b>
<div style="margin-left:20px;">
<?
$nsprefix=empty($_REQUEST['nsprefix'])?array(''=>''):$_REQUEST['nsprefix'];
foreach($nsprefix as $key=>$prefix) { ?>
<div name="ns">
<input style="width:50px;" type="text" name="nsprefix[]" value="<?=!empty($_REQUEST['nsprefix'][$key])?$_REQUEST['nsprefix'][$key]:''?>"/> FOR
<?=$s->edit('nsuri[]',!empty($_REQUEST['nsuri'][$key])?$_REQUEST['nsuri'][$key]:'',$namespaces)?>
</div>
<? } ?>
<a href="javascript:powl.duplicate('ns')" title="Add">[+]</a>
</div>
</div>
<div id="saved">
<?
$queries=array();
foreach(pwlGetSysOntClassInstances('RDQLQuery') as $q)
	$queries[$q->getLocalName()]=$q->getPropertyValuePlain('rdqlQueryTitle');
echo($s->edit('savedQuery',!empty($_REQUEST['savedQuery'])?$_REQUEST['savedQuery']:'',$queries));
?>
</div>
<br />
<input type="submit" value="<?=pwl_('Submit')?>" onclick="powl.wait(this)" />
</form>
<h2><?=pwl_('Result')?></h2>
<?
#$p=new RdqlParser();
#print_r($p->parseQuery($query));
if(!empty($query)) {
#echo(timer());
	$res=$_ET['rdfsmodel']->rdqlQuery($query);
#echo('<br>'.timer());
	$start=empty($_REQUEST['start'])?0:$_REQUEST['start'];
	$count=pwlSessionVar($_SERVER['PHP_SELF'],'count');
	$end=current($res[0])?count($res):0;
	echo(pwlListHead($start,$count,$end).'<table>');
	$i=0;
	if($end)
	foreach($res as $row) if(++$i>$start && $i<=$start+$count) {
		if($i==$start+1)
			echo('<tr><th>'.pwl_('No.').'</th><th>'.join('</th><th>',array_keys($row)).'</th></tr>');
		echo('<tr><th>'.$i.'</th>');
		foreach($row as $col) {
			echo('<td>'.pwlRenderNode($col).'</td>');
		}
		echo('</tr>');
	}
	echo('</table>');
}
pwlHTMLFooter(); ?>