<?php
	// $Id: include.php,v 1.12 2004/10/21 19:23:27 soerenauer Exp $

	/**
	* Check if a file exists in the include path
	*
	* @version      1.2
	* @author       Aidan Lister <aidan@php.net>
	* @param        string $file The name of the file to look for
	* @return       bool True if the file exists, False if it does not
	*/
	function file_exists_incpath ($file)
	{
	    $paths = explode(PATH_SEPARATOR, ini_get('include_path'));
	    //$paths = explode(':', ini_get('include_path'));

	    foreach ($paths as $path)
	    {
	        // Formulate the absolute path
	        $fullpath = $path . DIRECTORY_SEPARATOR . $file;

	        // Check it
	        if (file_exists($fullpath)) {
	            return true;
	        }
	    }

	    return false;
	}

    // powl Include
	if(empty($_POWL))
	    include_once(dirname($_SERVER['SCRIPT_FILENAME']).'/../../include.php');

    // set URI to webservices
    $_POWL['webserviceURL']='http://'.$_SERVER['SERVER_NAME'].$_POWL['uriBase'].'modules/webservice/server.php';

    // include for some nice functions
    include_once(constant('POWLAPI_INCLUDE_DIR').'include.php');

    // include functions for the webservice
    include_once('functions.inc.php');
    // automatic evaluation of technology (pear,nusoap,...)
	include_once('/etc/powl.config');
	if (!$forceToUse) {
		if ((file_exists_incpath('SOAP/Client.php'))&&(file_exists_incpath('SOAP/Server.php')))
		{
			// PEAR installed
			$tecPrefix = 'pear';
		}
		elseif ((file_exists('nusoap/lib/nusoap.php'))&&(defined('CURLVERSION_NOW')))
		{
			// nusoap lib and curl package installed
			$tecPrefix = 'nusoap';
		}
		else
		{
			// no technology for webservices found
			$tecPrefix = 'nowebservice';
		}
	}
	else
	{
		$tecPrefix = $forceToUse;
	}
?>