<?php

/**
 * pear_client.php
 * PEAR/SOAP/Client
 * 
 * @author Michael Haschke <haschek@users.sourceforge.net>
 * @version $Id: pear_client.php,v 1.3 2004/08/30 03:32:51 haschek Exp $
 **/

require_once('SOAP/Client.php');
include_once('pear_include.php');

class mysoapclient
{
	var $mysoapclient;
	var $mysoapclientFault;
	var $mysoapclientFaultMessage = NULL;

	function mysoapclient($server)
	{
		$this->mysoapclient = new SOAP_Client($server);
	}
	
	/**
	*  Call a function with parameters
	*  @param string $function a function name to call
	*  @param array $parameter an array with paramaters to function
	**/
	function mycall($function, $parameter)
	{
		$parameter = transformParameterArray ($function,$parameter);
		$this->mysoapclientFault = FALSE;
		$this->mysoapclientFaultMessage = NULL;
		$getData = $this->mysoapclient->call($function, $parameter,'urn:rdfabfrage');
		if ((is_object($getData))&&(get_class($getData)=='soap_fault'))
		{
			$this->mysoapclientFault = TRUE;
			$getError = getRealArray($getData);
			$this->mysoapclientFaultMessage = $getError['message'];
			$getData = NULL;
		}
		else
		{
			$getData = getRealArray($getData);
			if ((is_array($getData))&&(count($getData) == 1)&&(array_key_exists(0,$getData)))
				$getData = $getData[0];
			// DEBUGINFO echo "<pre>";  print_r($getData);   echo "</pre>";
		}
		return $getData;
	}
	
	/**
	*  is last operation fault?
	**/
	function isfault()
	{
		return $this->mysoapclientFault;
	}

	function getFaultMessage()
	{
		return $this->mysoapclientFaultMessage;
	}
}

$soapclient = new mysoapclient($_SESSION['server']);

?>