<?
/**
 * OWLModel
 * 
 * @package OWLAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: model.php,v 1.20 2005/03/01 18:52:45 soerenauer Exp $
 * @access public
 **/
class OWLModel extends RDFSModel {
	function OWLModel($store,$modelURI) {
		RDFSModel::RDFSmodel($store,$modelURI);
		$this->importsIds=array();
	}
	function addDatatypeProperty($uri) {
		$this->add($uri,'rdf:type','owl:DatatypeProperty');
		return new $this->property($uri,$this);
	}
	function addObjectProperty($uri) {
		$this->add($uri,'rdf:type','owl:ObjectProperty');
		return new $this->property($uri,$this);
	}
	/**
	 * Returns the OWL_ObjectProperties of the model
	 * 
	 * @return array Array of RDFSProperty objects.
	 **/
	function listObjectProperties() {
		return $this->listTypes($GLOBALS['OWL_ObjectProperty'],'RDFSProperty');
	}
	/**
	 * Returns the OWL_DatatypeProperties of the model
	 * 
	 * @return array Array of RDFSProperty objects.
	 **/
	function listDatatypeProperties() {
		return $this->listTypes($GLOBALS['OWL_DatatypeProperty'],'RDFSProperty');
	}
	function listTopClassesInfered() {
		if($topClasses=$this->listTopClasses())
		foreach($topClasses as $key=>$topClass)
			if(method_exists($topClass,'listIntersectionOf') && $inferedSuperClasses=$topClass->listIntersectionOf())
				foreach($inferedSuperClasses as $inferedSuperClass)
					if(!isBnode($inferedSuperClass))
						unset($topClasses[$key]);
		return $topClasses;
	}
	function listSubClassesInfered($class) {
		static $subClassesInfered;
		if(!is_array($subClassesInfered)) {
			$subClassesInfered=array();
			foreach($this->listTopClasses() as $key=>$topClass)
				if(method_exists($topClass,'listIntersectionOf') && $inferedSuperClasses=$topClass->listIntersectionOf())
					foreach($inferedSuperClasses as $inferedSuperClass)
						$subClassesInfered[$inferedSuperClass->getLocalName()][$topClass->getLocalName()]=$topClass;
		}
		return !empty($subClassesInfered[$class->getLocalName()])?$subClassesInfered[$class->getLocalName()]:array();
	}
	/**
	 * TODO: beschreibung
	 *
	 **/
	function setImports($imports) {
		$this->asResource->setPropertyValues($GLOBALS['OWL_imports'],$imports);
	}
	/**
	 * TODO: beschreibung
	 *
	 * @return array Array of RDFResources
	 **/	
	function listPriorVersion() {
		return $this->asResource->listPropertyValues($GLOBALS['OWL_priorVersion']);
	}
	/**
	 * TODO: beschreibung
	 *
	 **/
	function setPriorVersion($values) {
		$this->asResource->setPropertyValues($GLOBALS['OWL_priorVersion'],$values);
	}
	/**
	 * TODO: beschreibung
	 *
	 * @return array Array of RDFResources
	 **/	
	function listBackwardCompatibleWith() {
		return $this->asResource->listPropertyValues($GLOBALS['OWL_backwardCompatibleWith']);
	}
	/**
	 * TODO: beschreibung
	 *
	 **/
	function setBackwardCompatibleWith($values) {
		$this->asResource->setPropertyValues($GLOBALS['OWL_backwardCompatibleWith'],$values);
	}
	/**
	 * TODO: beschreibung
	 *
	 * @return array Array of RDFResources
	 **/	
	function listIncompatibleWith() {
		return $this->asResource->listPropertyValues($GLOBALS['OWL_incompatibleWith']);
	}
	/**
	 * TODO: beschreibung
	 *
	 **/
	function setIncompatibleWith($values) {
		$this->asResource->setPropertyValues($GLOBALS['OWL_incompatibleWith'],$values);
	}
	function listAllDifferentSets() {
		return $this->findNodes(NULL,$GLOBALS['RDF_type'],$GLOBALS['OWL_AllDifferent']);
	}
	function getAllDifferent($set,$class=NULL) {
		$distinctMembers=$this->findNode($set,$GLOBALS['OWL_distinctMembers'],NULL);
		return $this->getList($distinctMembers,$class);
	}
	function setAllDifferent($set,$members) {
		$this->removeAllDifferent($set);
		$this->addAllDifferent($members);
	}
	function addAllDifferent($members) {
		$allDifferent=new BlankNode($this->getUniqueResourceURI(BNODE_PREFIX));
		$this->add($allDifferent,$GLOBALS['RDF_type'],$GLOBALS['OWL_AllDifferent']);
		$distinctMembers=$this->addList($members,false);
		$this->add($allDifferent,$GLOBALS['OWL_distinctMembers'],$distinctMembers);
	}
	function removeAllDifferent($set) {
		if(!is_a($set,'RDFSResource'))
			$set=$this->resourceF($set);
		$set->remove();
	}
}
?>