<?
/**
 * Class that represents an RDFS ontology node characterising a class description.
 * 
 * @package RDFSAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: class.php,v 1.1 2005/02/06 10:58:44 soerenauer Exp $
 * @access public
 **/
class RDFSClass extends DefaultRDFSClass {
	function listInstanceLabels($language) {
		$ret=array();
		foreach($this->model->rdqlQuery('SELECT * WHERE (?x,<rdf:type>,<'.$this->getURI().'>) (?x,<rdfs:label>,?label) (?x,<'.$GLOBALS['_POWL']['SysOnt']->baseURI.'labelText'.'>,?labelText) (?x,<rdfs:comment>,?comment) (?x,<rdfs:seeAlso>,?seeAlso)') as $row)
			$ret[$row['?labelText']]=array($row['?label'],$row['?comment'],$row['?seeAlso']);
print_r($ret);
		return $ret;
	}
	function findInstances($properties=array(),$compare='exact',$start=0,$count=0,$erg=0) {
		$args=func_get_args();
		$c=cache('findInstances'.$this->model->modelURI.$this->getURI(),$args);
		if($c!==NULL)
			return $c;
		if(!$properties)
			return $this->listInstances($start,$count,&$erg);
		$ret=array();

		$sql='SELECT s.subject FROM statements s';
		$n=0;
		if($properties['localName']) {
			$where.=' AND s.subject LIKE "'.$properties['localName'].'%"';
			unset($properties['localName']);
		}
		foreach($properties as $property=>$value) {
			$prop=$this->model->resourceF($property);
			$sql.=($value?' INNER ':' LEFT ');
			$n++;
			if(!$value)
				$cond='1';
			else if($compare=='exact')
				$cond="s$n.object='".(is_a($value,'Resource')?$this->model->_dbId($value):$value)."'";
			else if($compare=='starts')
				$cond="s$n.object LIKE '$value%'";
			else if($compare=='contains')
				$cond="s$n.object LIKE '%$value%'";
			else if($compare=='regex')
				$cond="s$n.object REGEXP '$value'";
			else if($compare=='empty')
				$cond="ISNULL(s$n.object)";
				
			$sql.='JOIN statements s'.$n." ON(s.modelID=s$n.modelID AND s.subject=s$n.subject AND s$n.predicate='".$this->model->_dbId($prop)."' AND $cond)";
			if(!$value)
				$where.=" AND ISNULL(s$n.object)";
		}
		$sql.=' WHERE s.modelID IN ('.$this->model->getModelIds().') AND s.predicate=\''.$this->model->_dbId('RDF_type').'\'
			AND s.object=\''.$this->model->_dbId($this).'\''.(!empty($where)?$where:'').' GROUP BY s.subject';
#print_r($sql);
		if($count)
			$res=&$this->model->dbConn->PageExecute($sql,$count,$start/$count+1);
		else
			$res=&$this->model->dbConn->execute($sql);

		$erg=$res->_maxRecordCount?$res->_maxRecordCount:$res->_numOfRows;

		$ret=$this->model->_convertRecordSetToNodeList($res,$this->model->instance);
		cache('findInstances'.$this->model->modelURI.$this->getURI(),$args,$ret);
		return $ret;
	}
}
?>