<?
/**
 * RDFSStore
 * 
 * @package RDFSAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: store.php,v 1.2 2005/02/10 19:14:14 soerenauer Exp $
 * @access public
 **/

class POWLStore extends DefaultPOWLStore {
	/**
	 * Constructor:
	 * Set the database connection with the given parameters.
	 *
	 * @param   string   $dbDriver
	 * @param   string   $host
	 * @param   string   $dbName
	 * @param   string   $user
	 * @param   string   $password
	 * @access	public
	 */
	function POWLStore($dbDriver,$host,$dbName,$user,$password,$SysOntURI=false) {
		DBStore::DBStore($dbDriver,$host,$dbName,$user,$password);
		// if 'tablePrefix' is set, attach SQL-rewrite function to store
		if(!empty($GLOBALS['_POWL']['db']['tablePrefix']))
			$this->dbConn->fnExecute='pwlRewriteSQL';
		if($SysOntURI)
			$this->SysOnt=$GLOBALS['_POWL']['SysOnt']=$this->getModel($SysOntURI);
	}
	function _createTables_MySql() {
   $this->dbConn->startTrans();

   $this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."languages` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `language` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `language` (`language`)
);");
$this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."literals` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `value` text NOT NULL,
  `language` smallint(5) unsigned NOT NULL default '0',
  `datatype` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `language` (`language`),
  KEY `datatype` (`datatype`),
  KEY `value` (`value`(10))/*,
  FULLTEXT KEY `value_2` (`value`)*/
);");
$this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."ns` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `ns` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `ns` (`ns`)
);");
$this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."resources` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `ns` smallint(5) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `ns` (`ns`,`name`),
  KEY `name` (`name`)
);");
$this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."statements` (
  `modelID` smallint(5) unsigned NOT NULL default '0',
  `subject` mediumint(8) unsigned NOT NULL default '0',
  `predicate` mediumint(8) unsigned NOT NULL default '0',
  `object` mediumint(8) unsigned NOT NULL default '0',
  `object_is` enum('r','l') NOT NULL default 'r',
  UNIQUE KEY `stm` (`modelID`,`subject`,`predicate`,`object`,`object_is`),
  KEY `object` (`object`),
  KEY `modelID` (`modelID`),
  KEY `object_is` (`object_is`),
  KEY `subject` (`subject`),
  KEY `predicate` (`predicate`)
)");
$this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."models` (
  `modelID` bigint(20) NOT NULL default '0',
  `modelURI` varchar(255) NOT NULL default '',
  `baseURI` varchar(255) default '',
  PRIMARY KEY  (`modelID`),
  UNIQUE KEY `m_modURI_idx` (`modelURI`)
)");
$this->dbConn->execute("CREATE TABLE `".$GLOBALS['_POWL']['db']['tablePrefix']."namespaces` (
  `modelID` bigint(20) NOT NULL default '0',
  `namespace` varchar(255) NOT NULL default '',
  `prefix` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`modelID`,`namespace`),
  KEY `n_mod_idx` (`modelID`)
)");
   if (!$this->dbConn->completeTrans())
      echo $this->dbConn->errorMsg();
	}
}
?>